#!/bin/bash
# originally by Iguleder
# hacked to DEATH by 01micko
# Firmware download option big or cut from ibiblio.
# unattended wrapper by stemsee
# deblob-kernel-code libre-linux from Iguleder
# see /usr/share/doc/legal NO WARRANTY, NO responsibility accepted

CWD=`pwd`
Version="1.1"
timelimit=8
old=4.10.12
olsfix=PuPpY
aufs_utils_git=git://git.code.sf.net/p/aufs/aufs-util
FD=1
COMP="-comp xz"
# get today's date
today=`date +%d%m%y`
tmstamp=`date | cut -f1,2,3,4,5,7 -d ' ' | tr ' ' '-' | cut -f1,2 -d ':'`

#Compile and build
bldkern () {

if [[ -d ./aufs* ]]; then
	echo "This is not a clean kit."
	echo " CTRL+C to quit"
	read notcleango
fi

# delete the previous log
[ -f build.log ] && rm -f build.log
[ -f build.log.tar.bz2 ] && mv -f build.log-$tmstamp.tar.bz2

# the aufs major version
aufsv=${kernel_version%%.*}
# get the major version (2.6.32 in the case of 2.6.32.40)
kernel_major_version=$kernel_version #blah, hack for 3.x
# get the kernel branch (32 in the case of 2.6.32.40; needed to download Aufs)
kernel_branch=`echo $kernel_major_version | cut -f2 -d'.'` #3.x kernels

# delete the previous log
[ -f build.log ] && rm -f build.log
[ -f build.log.tar.bz2 ] && mv -f build.log.tar.bz2

#download kernel sources
if [[ `echo $kernel_version | rev | cut -f1 -d'.'` = 0 ]]; then
	kernel_version=`echo $kernel_version | cut -f1,2 -d'.'`
		echo "You can rename a previous aufs download. OK? 'y'"
		read ans
		case $ans in
		y) unset ball
		ball=`ls vanilla/`
		rm -f /tmp/aufsballs
		NU=0001
for C in $ball
  do echo "${NU}. $C" >> /tmp/aufsballs
	NU=$((NU + 1))
  done
  cat /tmp/aufsballs | rev | cut -f1 -d '/' | rev
  read elect
  balled=`cat /tmp/aufsballs | grep "$elect" | rev | cut -f1 -d'/' | rev`
		rename $balled aufs$ver-$kernel_branch-git$today.tar.bz2 vanilla/$balled;;
		*) ;;
		esac
fi
if [ ! -f vanilla/linux-$kernel_version.tar.xz ]; then
# download the kernel
echo ${kernel_version##*-} | grep -q "rc"
[ "$?" -eq 0 ] && testing=testing || testing=
	if [[ ! -f vanilla/linux-$kernel_version.tar.xz ]]; then
	echo "Downloading the kernel sources"
	wget --no-check-certificate -P vanilla $kernel_mirror/linux-$kernel_version.tar.xz 
		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the kernel sources."
			exit 1
		fi
	fi
elif [ -f vanilla/linux-$kernel_version.tar.xz ]; then
echo "Kernel Sources already there!"
fi

# download Linux-libre scripts
if [ $LIBRE -eq 1 ]; then
	minor_version=${kernel_version##*.}
	for i in deblob-$kernel_major_version deblob-check; do
		if [ ! -f vanilla/$i ]; then
			wget --no-check-certificate -O vanilla/$i http://linux-libre.fsfla.org/pub/linux-libre/releases/LATEST-"$aufsv".N/$i
			if [ $? -ne 0 ]; then
				echo "Error: failed to download $i."
				exit 1
			fi
		fi
	done
fi


# download Aufs
if [ ! -f vanilla/aufs$ver-$kernel_branch-git$today.tar.bz2 ]; then
	echo "Downloading the Aufs sources"
	if [ "$ver" -eq 4 ]; then
		git clone git://github.com/sfjro/aufs4-standalone.git aufs$ver-$kernel_branch-git$today
	elif [ "$ver" -eq 3 ]; then
		git clone https://git.code.sf.net/p/aufs/aufs3-standalone aufs-aufs$ver-standalone
	fi
	if [ $? -ne 0 ]; then
		echo "Error: failed to download the Aufs sources."
		sleep 4
		exit 1
	fi

	if [[ "$ver" = 3 ]]; then
		rename aufs-aufs$ver-standalone aufs"$ver"-"$kernel_branch"-git"$today" aufs-aufs$ver-standalone
	elif [[ "$ver" = 4 ]]; then
		rename master aufs"$ver"-"$kernel_branch"-git"$today" master
	fi
	cd aufs$ver-$kernel_branch-git$today
	if [ "$aufsv" ];then #new var for new kernels
		git checkout origin/aufs$ver.$kernel_branch
	else
		git checkout origin/aufs$ver.$kernel_branch
	fi
	if [ $? -ne 0 ]; then
		echo "Error: failed to download the Aufs sources."
		exit 1
	fi
	rm -rf .git
	cd ..
	echo "Creating the Aufs sources tarball"
	tar -c aufs$ver-$kernel_branch-git$today | bzip2 -9 > vanilla/aufs$ver-$kernel_branch-git$today.tar.bz2
else
	echo "Extracting the Aufs sources"
	tar xf vanilla/aufs$ver-$kernel_branch-git$today.tar.bz2 >> build.log 2>&1
	if [ $? -ne 0 ]; then
		echo "Error: failed to extract the Aufs sources."
		exit 1
	fi
fi

# patch Aufs
if [ -f aufs-allow-sfs.patch ];then #removed for K3.9 experiment
	echo "Patching the Aufs sources"
	patch -d aufs$ver-$kernel_branch-git$today -p1 < aufs-allow-sfs.patch >> build.log 2>&1
	if [ $? -ne 0 ]; then
		echo "Error: failed to patch the Aufs sources."
		exit 1
	fi
	cp aufs-allow-sfs.patch patches
fi
if [ -f aufs-kconfig.patch ];then #special for K3.9
	echo "Patching the Aufs sources"
	patch -d aufs$ver-$kernel_branch-git$today -p1 < aufs-kconfig.patch >> build.log 2>&1
	if [ $? -ne 0 ]; then
		echo "Error: failed to patch the Aufs sources for kconfig."
		exit 1
	fi
	cp aufs-kconfig.patch patches
fi

# extract the kernel
echo "Extracting the kernel sources"
tar xf vanilla/linux-$kernel_version.tar.* >> build.log 2>&1
if [ $? -ne 0 ]; then
	echo "Error: failed to extract the kernel sources."
	exit 1
fi

cd linux-$kernel_version

echo "Adding Aufs to the kernel sources"
for i in kbuild base standalone mmap; do
	patch -N -p1 < ../aufs$ver-$kernel_branch-git$today/aufs$ver-$i.patch >> ../build.log 2>&1
	if [ $? -ne 0 ]; then
		echo "Error: failed to add Aufs to the kernel sources."
		exit 1
		echo "WARNING: failed to add some Aufs patches to the kernel sources."
		echo "Check it manually and either CRTL+C to bail or hit enter to go on"
		sleep 2
	fi
done

#aufspatch

cp -r ../aufs$ver-$kernel_branch-git$today/{fs,Documentation} .
cp ../aufs$ver-$kernel_branch-git$today/include/linux/aufs_type.h include/linux 2>/dev/null
cp ../aufs$ver-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/linux 2>/dev/null
[ -d ../aufs$ver-$kernel_branch-git$today/include/uapi ] && \
cp -r ../aufs$ver-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/uapi/linux

# deblob the kernel
if [ $LIBRE -eq 1 ]; then
	cd ..
	cp -r linux-$kernel_version linux-$kernel_version-orig
	cd linux-$kernel_version
	sh ../vanilla/deblob-$kernel_major_version 2>&1 | tee -a ../build.log
	cd ..
	diff -rupN linux-$kernel_version-orig linux-$kernel_version > patches/deblob.patch
	rm -rf linux-$kernel_version-orig
	cd linux-$kernel_version
fi

echo "Resetting the minor version number"
cp -f Makefile Makefile-orig
sed -i "s/^EXTRAVERSION =/EXTRAVERSION = $custom_suffix/" Makefile
diff -up Makefile-orig Makefile > ../patches/extra-version.patch
rm Makefile-orig

	 cp kernel/printk/printk.c kernel/printk/printk.c.orig
	 sed -i s/'#define MAX_CMDLINECONSOLES 8'/'#define MAX_CMDLINECONSOLES 5'/ kernel/printk/printk.c
	 diff -up kernel/printk/printk.c.orig kernel/printk/printk.c > ../patches/less-consoles.patch
	 echo "Reducing the verbosity level"
	 cp -f include/linux/printk.h include/linux/printk.h.orig
	 sed -i s/'#define CONSOLE_LOGLEVEL_DEFAULT 7 \/\* anything MORE serious than KERN_DEBUG \*\/'/'#define CONSOLE_LOGLEVEL_DEFAULT 3 \/\* anything MORE serious than KERN_ERR \*\/'/ include/linux/printk.h
	 diff -up include/linux/printk.h.orig include/linux/printk.h > ../patches/lower-verbosity.patch

#patches
for patch in ../patches/*; do
	echo "Applying $patch"
	patch -p1 < $patch >> ../build.log 2>&1
	if [ $? -ne 0 ]; then
		echo "Error: failed to apply $patch on the kernel sources."
	fi
	cp $patch ../patches
done

#cleaningsrc
echo "Cleaning the kernel sources"
if [ -z "$DEB" ]; then
	make clean
	make mrproper
else
	make-kpkg clean
fi
find . -name '*.orig' -delete
find . -name '*.rej' -delete
find . -name '*~' -delete

[ ../DOTconfig ] && rm -f ../DOTconfig
case $car in
1) cp -af ../configs_extra_user/DOTconfig-64 ../DOTconfig;;
2) cp -af ../configs_extra_user/DOTconfig-pae ../DOTconfig;;
3) cp -af ../configs_extra_user/DOTconfig-nopae ../DOTconfig;;
esac
#Pause to configure
#configure
clear
echo -e "For unattended config of new kernels do nothing here!
For old kernel versions or other customisations enter 2 ... 

1. make olddefconfig
2. make menuconfig 
3. make oldconfig
$timelimit seconds\n: \c"
echo
read -t $timelimit kernelconfig
if [ ! -z "$kernelconfig" ]; then
	echo -e "\n You entered '$kernelconfig'"
else
	echo -e "\n TIME OUT\n Assume default."
	kernelconfig=3
fi
if [ "$arc" = 888 ]; then
	kernelconfig=2
fi
cp -f ../DOTconfig .config.old
cp -f ../DOTconfig .config

case $kernelconfig in
1) make olddefconfig;;
2) echo "Configure 64 bit kernel"
sleep 2
make menuconfig
if [ "$arc" = 888 ]; then
mv -f .config ../configs_extra_user/DOTconfig-64
mv -f ../configs_extra_user/DOTconfig-pae .config
echo "Configure pae kernel."
sleep 2
make menuconfig
mv -f .config ../configs_extra_user/DOTconfig-pae
sed -i "s/$nwsfix-64/$nwsfix-pae/" ../configs_extra_user/DOTconfig-pae
mv -f ../configs_extra_user/DOTconfig-nopae .config
echo "Configure nopae kernel."
sleep 2
make menuconfig
mv -f .config ../configs_extra_user/DOTconfig-nopae
sed -i "s/$nwsfix-64/$nwsfix-nopae/" ../configs_extra_user/DOTconfig-nopae
cp -f ../configs_extra_user/DOTconfig-64 .config
echo "Finished and continuing to compile 64 bit kernel."
fi;;
3) make oldconfig;;
esac

echo
echo "Ok, kernel is configured. CTRL+C to quit"
sleep 2

[ ! -d ../dist/packages ] && mkdir -p ../dist/packages

#krnheads
if [ ! -d ../dist/kernel_headers-$kernel_major_version-$package_name_suffix ]; then
	echo "Creating the kernel headers package"
	make headers_check >> ../build.log 2>&1
	make INSTALL_HDR_PATH=kernel_headers-$kernel_major_version-$package_name_suffix/usr headers_install >> ../build.log 2>&1
	find kernel_headers-$kernel_major_version-$package_name_suffix/usr/include \( -name .install -o -name ..install.cmd \) -delete
	mv kernel_headers-$kernel_major_version-$package_name_suffix ../dist/
fi

#krncompile
echo "Compiling the kernel"
cores=`cat /proc/cpuinfo | grep 'cpu cores' | cut -f3 -d ' ' | tr '\n' ' ' | cut -f1 -d ' '`
threads=$((cores * 3))
if [ "$cores" -ge 2 ]; then
	if [[ -z "$DEB" ]]; then
		make -j"$threads"
	elif [[ ! -z "$DEB" ]]; then
		mkdir ./debian
		fakeroot make-kpkg -j"$threads" --initrd --revision="$latest.$nwsfix" kernel_image kernel_headers
		make clean
		cd ..
		mksquashfs linux-"$latest" kernel_sources-"$latest".sfs -comp xz
	fi
else
	if [[ -z "$DEB" ]]; then
		make
	elif [[ ! -z "$DEB" ]]; then
		mkdir ./debian
		fakeroot make-kpkg --initrd --revision="$latest.$nwsfix" kernel_image kernel_headers
		make clean
		cd ..
		mksquashfs linux-"$latest" kernel_sources-"$latest".sfs -comp xz
	fi
fi
if [[ -z "$DEB" ]]; then
if [[ ! -f arch/x86/boot/bzImage || ! -f System.map ]]; then
	echo "Error: failed to compile the kernel sources."
	exit 1
fi
cp .config ../configs_extra/DOTconfig-$kernel_version-$timestamp

#krncompile
echo "Creating the kernel package"
make INSTALL_MOD_PATH=linux_kernel-$kernel_major_version-$package_name_suffix modules_install >> ../build.log 2>&1
rm -f linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{build,source}
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/boot
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules
cp .config linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/DOTconfig-$kernel_version-
cp arch/x86/boot/bzImage linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz
BZIMAGE=`find . -type f -name bzImage`
cp System.map linux_kernel-$kernel_major_version-$package_name_suffix/boot/
cp linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{modules.builtin,modules.order} \
 linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/
mv linux_kernel-$kernel_major_version-$package_name_suffix ../dist/packages/
if [ "$FD" = "1" ]; then #make fatdog kernel module package
	mv ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz ../dist/packages/vmlinuz-$kernel_major_version-$package_name_suffix"$arch"
	[[ -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage ]] && rm -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage
	echo "Huge kernel $kernel_major_version-$package_name_suffix is ready in dist"
fi
echo "Cleaning the kernel sources"
make clean >> ../build.log 2>&1
make prepare >> ../build.log 2>&1

cd ../

# build aufs-utils userspace modules
echo "Now to build the aufs-utils for userspace"
if [ ! -f vanilla/aufs-util${today}.tar.bz2 ];then
	git clone "$aufs_utils_git" aufs-util
	[ $? -ne 0 ] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)"
	
	cd aufs-util
	
	git branch -a | grep "aufs${ver}" |grep -v 'rcN' | cut -d '.' -f2 > /tmp/aufs-util-version #we go for stable only
	while read line
	  do 
	    if [ "$kernel_branch" = "$line" ];then branch=$line
	    else
	      while [ "$kernel_branch" -gt "$line" ]
	        do branch=$line
	        echo $branch && break
	        done 
	    fi
	  done < /tmp/aufs-util-version
	git checkout origin/aufs${ver}.${branch} >> ../build.log 2>&1
	
	[ $? -ne 0 ] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)"
	# patch Makefile for static build
	echo "Patching aufs-util sources"
	cp -f Makefile Makefile.orig
	sed -i 's/-static //' Makefile
	#rm ../patches/aufs-util-dynamic.patch
	diff -ru Makefile.orig Makefile > ../patches/aufs-util-dynamic.patch
	rm *.orig
	else
	echo "Extracting the Aufs-util sources"
	tar xf vanilla/aufs-util$today.tar.bz2 >> ../build.log 2>&1
	if [ $? -ne 0 ]; then
		echo "Error: failed to extract the aufs-util sources."
		exit 1
	fi	
	cd aufs-util	
	patch -p1 < ../patches/aufs-util-dynamic.patch >> ../build.log 2>&1
	[ "$?" -ne 0 ] && echo "Failed to patch the aufs-util sources, do it manually. Kernel is compiled ok"
fi
# see if fhsm is enabled in kernel config
CONFIG=`find $CWD/linux-* -type f -name '.config'`
grep -q 'CONFIG_AUFS_FHSM=y' $CONFIG
[ "$?" -eq 0 ] && export MAKE=make || export MAKE="make BuildFHSM=no"
LinuxSrc=`find $CWD -type d -name 'kernel_headers*'`
export CPPFLAGS="-I $LinuxSrc/usr/include"
$MAKE >> ../build.log 2>&1
[ $? -ne 0 ] && echo "Failed to compile aufs-util, do it manually. Kernel is compiled OK :)"
make DESTDIR=$CWD/dist/packages/aufs-util-$kernel_version-$arch install >> ../build.log 2>&1 #needs absolute path
make clean >> ../build.log 2>&1
if [ "$arch" = "x86_64" ];then
[[ $CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib ]] && mv $CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib \
$CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib64
fi
echo "aufs-util-'$kernel_version' is in dist"
cd ..

if [ "$FD" = "1" ]; then #shift aufs-utils to kernel-modules.sfs
	echo "Installing aufs-utils into kernel package"
	cp -a dist/packages/aufs-util-$kernel_version-$arch/* \
	dist/packages/linux_kernel-$latest-$package_name_suffix/
	rm -rf dist/packages/aufs-util-$kernel_version-$arch
	if [[ -z "$DEB" ]]; then
		cp -r /lib/firmware dist/packages/linux_kernel-$latest-$package_name_suffix/lib/
	fi
	tar -xjf /tmp/firmware-*-*.tar.bz2 -C dist/packages/linux_kernel-$latest-$package_name_suffix/lib/
	cp -r dist/kernel_headers-$latest-$package_name_suffix/usr/include dist/packages/linux_kernel-$latest-$package_name_suffix/usr/
	rm -rf dist/kernel_headers-$latest-$package_name_suffix
	mksquashfs dist/packages/linux_kernel-"$latest"-"$package_name_suffix"* dist/packages/kernel-modules.sfs-"$latest"-"$package_name_suffix""$arch" $COMP
	rm -rf dist/packages/linux_kernel-"$latest"-"$package_name_suffix"
	echo "Packaging huge-'$latest'-'$package_name_suffix' kernel"
	cd dist/packages/
	tar -cjvf huge-$latest-${package_name_suffix}"$arch".tar.bz2 \
	vmlinuz* kernel-modules.sfs*
	md5sum huge-$latest-${package_name_suffix}"$arch".tar.bz2 > huge-$latest-${package_name_suffix}"$arch".tar.bz2.md5.txt
fi
fi
cd $CWD
clear
echo " Done!"
[ -f /usr/share/sounds/2barks.au ] && aplay /usr/share/sounds/2barks.au
}

mkkernsrc () {
	echo "Creating a kernel sources SFS" > build.log 2>&1
	mkdir -p kernel_sources-$latest-$package_name_suffix/usr/src > build.log 2>&1
	mv linux-$kernel_version kernel_sources-$latest-$package_name_suffix/usr/src/linux > build.log 2>&1
	mkdir -p kernel_sources-$latest-$package_name_suffix/lib/modules/${latest}$custom_suffix > build.log 2>&1
	cd kernel_sources-$latest-$package_name_suffix/lib/modules/${latest}$custom_suffix/
	ln -s /usr/src/linux build > build.log 2>&1
	[ ! -f usr/src/linux/include/linux/version.h ] && \
	ln -s /usr/src/linux/include/generated/uapi/linux/version.h usr/src/linux/include/linux/version.h  > build.log 2>&1
	ln -s /usr/src/linux source > build.log 2>&1
	cd $CWD
	mksquashfs kernel_sources-$latest-$package_name_suffix dist/packages/kernel_sources-$latest-$package_name_suffix"$arch"-$tmstamp.sfs $COMP -noappend > build.log 2>&1
	[[ ! -d debs ]] &&	mkdir debs
	[[ *.deb ]] && mv *.deb debs/
	[[ *.sfs ]] && mv *.sfs debs/
}


if [ "$1" = makesources ]; then
	[[ /tmp/sukkvars ]] && . /tmp/sukkvars
	mkkernsrc
	exit 0
fi
if [ "$1" = reset ]; then
	rm -f vanilla/linux-*
	rm -f vanilla/aufs*
	rm -rf dist/kernel_headers*
	rm -f /root/.megaconf
	rm -rf /root/.gdrive
	rm -f /tmp/firmware-*
	rm -f /tmp/megatools*
	rm -f vanilla/deblob*
	rm /usr/sbin/drive
	rm /tmp/sukkvars
fi
cd "$CWD"
read -p "Press ENTER to begin, or 
'ctrl + c' then type './ubuild.sh reset' to start very clean." dummy
	echo -en "\033[1;35m""WARNING" #purple?
	echo -en "\033[0m" #reset
	echo "Cleaning."
	sleep 2
	echo "Please wait..."
	rm -rf ./{aufs*,linux*,kernel*,build.log*}
	rm -f build.log.bz2
	rm -f /tmp/aufs-util-version
	rm -f /tmp/sukkvars
	echo "Cleaning complete"
	
#fakeroot make-kpkg --initrd --revision="$latest-$nwsfix-$arch" kernel_image kernel_headers
echo "Please enter which kernel/s to build

e.g.    1) 64bit
        2) 32bit-pae
        3) 32bit-nopae
    or
      888) To reconfigure all 3 DOTconfig files and then build all kernels.
    or
        7) To build single modules or build kernel from kernel_sources-*.sfs!

e.g.   '1'  or  '2'  or  '3'  or  '12' or '23' or '13' or '123' 
	
	for debian system packages add deb (can build one kernel at a time)
		e.g. '1 deb' '2 deb'"

read arc DEB
echo "arc=$arc"
if [ -z "$arc" ]; then
	arc="123"
fi
if [ "$arc" = 7 ]; then
	cp buildfromsrc 
	cd dist/sources
	./buildfromsrc
exit
fi
echo "$arc" 

mkdir -p dist/previouspkgs-"$today" 
if [ -d dist/package* ]; then
	mv -f dist/packag* dist/previouspkgs-"$today" 
fi

echo "Please now enter the kernel version you would like this script to compile.
Current version setting is '$old' 
e.g.    4.4.0"
read latest
if [ -z "$latest" ]; then
	latest="$old"
fi
echo "'$latest'" 

nafsv=`echo $latest | cut -f1,2 -d'.'`
ver=`echo $latest | cut -f1 -d'.'`
kernel_version=$latest
kernel_mirror="https://cdn.kernel.org/pub/linux/kernel/v$ver.x/"
aufs_git=git://github.com/sfjro/aufs$ver-standalone.git
echo
echo "You can change the custom name on the kernel. Better not use minus symbol -.
Presently it is '$olsfix'. For debian system use lowercase only."
read nwsfix

if [ -z "$nwsfix" ]; then
	nwsfix="$olsfix"
fi
echo "'$nwsfix'" 
package_name_suffix=$nwsfix

clear
echo "To download firmware enter b or s,
big=16.6M | small=9.7M
to NOT download press enter."
read firmdl
case $firmdl in
	b)  wget -t0 -c http://distro.ibiblio.org/puppylinux/firmware/firmware-140621-big.tar.bz2 -P /tmp/;;
	s)  wget -t0 -c http://distro.ibiblio.org/puppylinux/firmware/firmware-140621-cut.tar.bz2 -P /tmp/;;
	*) ;;
esac
echo
echo "This option removes non-free frimware from kernel.
Deblob kernel? 'y' or Enter for 'no'"
read LIBRE
case $LIBRE in
	y) LIBRE=1;;
	n) LIBRE=0;;
	*) LIBRE=0;;
esac
case $firmdl in
	b)  wget -t0 -c http://distro.ibiblio.org/puppylinux/firmware/firmware-140621-big.tar.bz2 -P /tmp/ ;;
	s)  wget -t0 -c http://distro.ibiblio.org/puppylinux/firmware/firmware-140621-cut.tar.bz2 -P /tmp/ ;;
	*) ;;
esac
# depcheck
echo "Dependency check..."
if [ ! -z "$DEB" ]; then
	echo "For deb these packages must be installed:
	fakeroot build-essential kernel-package libssl-dev git ncurses-dev bc
	linux-headers-amd64 or linux-headers-x86 or i386 i686 etc.
	Install will be attempted now if you press 'i'"
	read install
	if [[ "$install" = i ]]; then
		doit=`which apt-get`
		if [[ ! -z "$doit" ]]; then
			sudo apt-get -y install fakeroot build-essential kernel-package git ncurses-dev linux-headers-* libssl-dev bc -y
		else
			go=`which gslapt-get`
			if [[ ! -z "$doit" ]]; then
				sudo gslapt-get -y install fakeroot build-essential kernel-package git ncurses-dev linux-headers-* libssl-dev bc -y
			fi
		fi
	fi
	if fakeroot --version &>/dev/null
		then echo -e "\033[1;32m""fakeroot is installed" #green 
	else echo -e "\033[1;31m""fakeroot might not be installed""\033[0m" #red
	fi
fi
if git --version &>/dev/null
	then echo -e "\033[1;32m""git is installed" #green 
else echo -e "\033[1;31m""git is not installed""\033[0m" && exit #red
fi
if gcc --version &>/dev/null
	then echo -e "\033[1;32m""gcc is installed" 
else
   echo -e "\033[1;31m""gcc is not installed""\033[0m" && exit
fi
MKSQ="$(which mksquashfs)"
if [ "$MKSQ" ]
	then 
   echo -e "\033[1;32m""mksquashfs is installed"
else #yellow
   echo -e "\033[1;30m""mksquashfs is not installed but you can continue"
fi
echo -e "\033[0m" #reset to original

xis=$arc
case $xis in
	1) arch=x86_64
	kern=64
	olsfix=-PuPpY-$kern;;
	2) arch=i686
	kern=32-pae
	olsfix=-PuPpY-$kern;;
	3) arch=i486
	kern=32-nopae
	olsfix=-PuPpY-$kern;;
esac

case $arc in
	1|2|3) car=$arc
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
	fi
	rename packages packages$kern dist/packages
	;;
	
	12) car=1
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages$kern dist/packages
	fi
	car=2
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages$kern dist/packages
	fi;;
	
	13)  car=1
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages64 dist/packages
	fi
	car=3
	bldkern
	if [[ -z "$DEB" ]]; then
		mkkernsrc
		rename packages packages32-nopae dist/packages
	fi;;
	
	23) car=2
	bldkern
	if [[ -z "$DEB" ]]; then
		mkkernsrc
		rename packages packages32-pae dist/packages
	fi
	car=3
	bldkern
	if [[ -z "$DEB" ]]; then
		mkkernsrc
		rename packages packages32-nopae dist/packages
	fi
	;;
	
	123) car=1
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages64 dist/packages
	fi
	car=2
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages32-pae dist/packages
	fi
	car=3
	bldkern
	if [[ -z "$DEB" ]]; then
		mkkernsrc
		rename packages packages32-nopae dist/packages
	fi
	;;
	
	888)	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages64 dist/packages
	fi
	car=2
	bldkern
	if [[ -z "$DEB" ]]; then 
		mkkernsrc
		rename packages packages32-pae dist/packages
	fi
	car=3
	bldkern
	if [[ -z "$DEB" ]]; then
		mkkernsrc
		rename packages packages32-nopae dist/packages
	fi
	;;
		
	7) cd dist/sources
	./buildfromsrc
	;;
esac
cd "$CWD"
mv DOTconfig-* configs_xtra/ > /dev/null
rm -f dist/kernel_headers* > build.log 2>&1
rm -f /tmp/firmware-*-*.tar.bz2 > build.log 2>&1
rm -rf kernel_sources-* > build.log 2>&1
rm -rf aufs* > build.log 2>&1
rm -f DOTconfig
dodo=`cat /etc/DISTRO_SPECS | grep -e 'FatDog' -e 'fatdog' -e 'quirky' -e 'Quirky' -e 'lighthouse' -e 'Lighthouse' -e 'Xenial' -e 'xenial'`
if [ -z "$dodo" ]; then
echo "Compilation has finished.
Do you want the script to upgrade your working kernel and modules?
'y' or 'n'"
read upgrade
case $upgrade in
n) exit 0;;
y) case $arc in
		1) kern=64;;
		2) kern=32-pae;;
		3) kern=32-nopae;;
	esac;;
esac
	if [[ ! -z "$DEB" ]]; then
		for file in linux-image-"$latest"*.deb linux-headers-"$latest"*.deb
		do
			dpkg -i "$file"
			mkdir -p /tmp/modules/lib
			cp -r /lib/"$latest"* /tmp/modules/lib
			mksquashfs /tmp/modules /live/image/live/modules.squashfs
			sync
		done
	else
		echo "Install new kernel (vmlinuz) and kernel-modules.sfs where?
		enter path  e.g. /mnt/sda6/Tahr/"
		read inst
		if [[ -e "$inst"vmlinuz ]]; then
			. /etc/DISTRO_SPECS
			rename "$zdrv1" "$zdrv1"-bak "$inst""$zdrv1"
			rename vmlinuz vmlinuz-bak "$inst"vmlinuz
			cp -f dist/packages"$kern"/vmlinuz* "$inst"vmlinuz
			cp -f dist/packages"$kern"/kernel-modules.sfs* "$inst""zdrv1"
			sync
			rox "$inst"
			echo "All Done!"
		fi
	fi
fi
sleep 2
exit 0
###the end###
